/**
 * @file event_handler.js
 * 
 * @brief This file contain implementation of the event handling from the upnp
 *        ui.
 * 
 * @author: mobile2DS
 * 
 * @date: 03.08.2013
 */

var lWarn = {
	logln : function(o) {
	}
};
var lInfo = {
	logln : function(o) {
	}
};



var LOGFILE_NAME = "upnp-controller.log";
lWarn = new Logger(LOGFILE_NAME);
//lInfo = new Logger(LOGFILE_NAME);

var arraySkipCheckingPriority = new Array(1111, 1112); // skip checking
// priority for volume
// up, down

/*
 * ---------------------------------------------------------------------------
 * SAVE/LOAD data related operations
 */
function storeSubParameter(root, path, value) {
	Property.setProperty(root + '/' + path, value);
	Property.setFlag(root + '/' + path, 'ARCHIVE', true);
	lInfo.logln("STORING " + root + "/" + path + " -> " + value);
}

function loadSubParameter(root, path) {
	var sub_param_value = null;
	var full_path = root + '/' + path;

	lInfo.logln('Search for sub parameter in: ' + full_path);

	var baseNode = Property.getNode(full_path);
	if (baseNode != null) {
		sub_param_value = baseNode.getValue();

		lInfo.logln(baseNode.getValue());
	} else {
		lWarn.logln('This sub parameter does not exists');
	}

	return sub_param_value;
}

/*
 * zoneID : roomID, if 0 - means global for whole apartment groupID : if 0 its
 * global (all) groups, 4 - sound group sceneID : >0 preset1-4,preset11-14, <0
 * activitiesID (-1: DoorBell -> -8: Waking up)
 */
function getInfo(zoneID, sceneID, groupID) {
	Property.load();
	var aData = Property.getNode('upnp-players');
	var oResult = new Array();

	var oArrayNode = aData.getChildren();
	var arrayAllRooms = [ -1, -2, -3, -4, -5, -6, 1113 ];

	for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {

		var oChildNode = oArrayNode[iIndex];
		if (oChildNode.getChild('id') != null) {
			var nID = oChildNode.getChild('id').getValue();
		} else {
			// skip null player
			continue;
		}
		var sPlay = "";

		var bSetDefaultLoudnessOnStop = Property.getProperty("/scripts/upnp-controller/activity/" + nID + "/useDefaultLoudness");
		var nDefaultLoudnessOnStop = Property.getProperty("/scripts/upnp-controller/activity/" + nID + "/defaultLoudness");
		var bStopOnLeavingHome = Property.getProperty("/scripts/upnp-controller/activity/" + nID + "/stopWhenAway");
		var nNewAction = arrayAllRooms.indexOf(sceneID);
		if ((groupID == 0) && (zoneID == 0) && (nNewAction > -1)) { // for
			// scenes
			// doorbell
			// -> alarm
			// 2,
			// leaving
			// home that
			// are not
			// assigned
			// to single
			// a room
			sPlayField = "valueActivity" + Math.abs(sceneID);
			if (sceneID == 1113) { // leaving home
				if (bStopOnLeavingHome) // stop only when checked
					sPlay = UPNP_STOP;
			} else
				sPlay = Property.getProperty("/scripts/upnp-controller/activity/" + nID + "/" + sPlayField);

			if (sPlay.trim() != "") {
				oResult.push(new Object({
					'id' : oChildNode.getChild('id').getValue(),
					'device' : oChildNode.getChild('typeID').getValue(),
					'ip' : oChildNode.getChild('ipAddress').getValue(),
					'port' : oChildNode.getChild('port').getValue(),
					'playlist' : sPlay,
					'useDefLoudness' : bSetDefaultLoudnessOnStop,
					'nDefLoudness' : nDefaultLoudnessOnStop,
					'nDoorbellPlayTime' : Property.getProperty("/scripts/upnp-controller/activity/" + nID + "/doorbellPlayTime"),
					'bResumeAfterAlarms' : Property.getProperty("/scripts/upnp-controller/activity/" + nID + "/stopOnUndo")
				}));
			}
		} else // searching for players in specific room
		if (((groupID == 4) || (groupID == 0)) && (zoneID > 0) && (oChildNode.getChild('roomID').getValue() == zoneID)) {
			lInfo.logln("room found, sceneField:" + sceneID + ", groupID:" + groupID);

			var sPlayField = "";
			if (sceneID > 0 && sceneID < 30)
				sPlayField = "valuePreset" + sceneID;
			else if (sceneID <= -6 && sceneID > -20)
				sPlayField = "valueActivity" + Math.abs(sceneID);
			lInfo.logln("playfield:" + sPlayField);

			if (sPlayField != "") {
				sPlay = Property.getProperty("/scripts/upnp-controller/activity/" + nID + "/" + sPlayField);
				lInfo.logln("/scripts/upnp-controller/activity/" + nID + "/" + sPlayField + " / " + sPlay);
			}
			bSetDefaultLoudnessOnStop = Property.getProperty("/scripts/upnp-controller/activity/" + nID + "/useDefaultLoudness");
			nDefaultLoudnessOnStop = Property.getProperty("/scripts/upnp-controller/activity/" + nID + "/defaultLoudness");

			oResult.push(new Object({
				'id' : oChildNode.getChild('id').getValue(),
				'device' : oChildNode.getChild('typeID').getValue(),
				'ip' : oChildNode.getChild('ipAddress').getValue(),
				'port' : oChildNode.getChild('port').getValue(),
				'playlist' : sPlay,
				'useDefLoudness' : bSetDefaultLoudnessOnStop,
				'nDefLoudness' : nDefaultLoudnessOnStop
			}));
			break;
		}
	}
	return oResult;
}

function convertCallSceneID(nCallSceneID) {
	var scene_idx = -1;
	var action_id = 0;

	var scene_id_list = new Array(0 // OFF
	, 5, 17, 18, 19, 33, 20, 21, 22 // presets 1..4, 11.14
	// activities
	, 73 // doorbell
	, 71 // coming home
	, 76 // Fire
	, 65 // Panic
	, 74 // Alarm 1
	, 83 // Alarm 2
	, 69 // Sleep
	, 70 // Waking up
	, 11 // volume -
	, 12 // volume +
	, 32 // preset 10
	, 67 // stand by
	, 68 // deep off
	, 72 // leaving home
	, 34 , 35, 23 , 24 ,25 // preset 20 - 24
	);
	var action_id_list = new Array(999 // preset 0 - stop
	, 1, 2, 3, 4, 11, 12, 13, 14 // presets
	, -1, -2, -3, -4, -5, -6, -7, -8 // activities
	, 1111, 1112 // volume
	, 999, 999, 999 // stop
	, 1113 // leaving home
	, 20, 21, 22, 23, 24 // preset 20 - 24
	);

	var priority_list = new Array(1 // preset 0 - stop
	, 1, 1, 1, 1, 1, 1, 1, 1 // presets
//	, 10, 1, 30, 20, 100, 50, 1, 1 // activities
	, 1, 1, 1, 1, 1, 1, 1, 1 // activities
	, -1, -1 // volume
	, 1, 1, 1 // stop
	, 1 // leaving home
	, 1, 1, 1, 1, 1 // preset 20 - 24
	);

	lInfo.logln("inside");
	var i = 0;
	for (i = 0; i < scene_id_list.length; i++) {
		if (scene_id_list[i] == nCallSceneID) {
			// got index of this scene ID
			scene_idx = i;
			action_id = action_id_list[i];
			scene_priority = priority_list[i];
			lInfo.logln("have found pair scene id " + scene_idx + " and action id " + action_id);
			break;
		}
	}

	return new Object({
		'action_id' : action_id,
		'scene_priority' : scene_priority
	});
	// return action_id;
}

/*
 * ---------------------------------------------------------------------------
 * EVENT handling
 */
if (raisedEvent.name === 'callSceneBus') {
	lInfo.logln("event name: ", raisedEvent.name);
	if (raisedEvent.source.isDevice) {
		lInfo.logln("parameter device dSID: ", raisedEvent.source.dsid);
	} else {
		lInfo.logln("  parameter groupID: ", raisedEvent.source.groupID);
	}
	lInfo.logln("  parameter zoneID:  ", raisedEvent.source.zoneID);
	lInfo.logln("  parameter sceneID: ", raisedEvent.parameter.sceneID);

	var nGroupID = raisedEvent.source.groupID;

	if (nGroupID == 0 || nGroupID == 4) {
		var callData = convertCallSceneID(raisedEvent.parameter.sceneID);

		var action_id = callData.action_id;
		var scene_priority = callData.scene_priority;

		if (action_id != 0) {
			// checking dSS stored scene priority
			var nStoredActivePriority = 0;
			nStoredActivePriority = loadSubParameter('upnp', 'activeScenePriority');
			if (isNaN(nStoredActivePriority))
				nStoredActivePriority = 0;
			// events that are allways executed
			var bSkipPriorityCheck = (arraySkipCheckingPriority.indexOf(action_id) > -1);
			bSkipPriorityCheck = true;
			lInfo.logln("Testing priority stored:" + nStoredActivePriority + " / " + " called scene priority:" + scene_priority);
			if (bSkipPriorityCheck || ((action_id != -1 && scene_priority >= nStoredActivePriority) || (action_id == -1 && scene_priority > nStoredActivePriority) // special
			// conditions
			// "doorbell"
			// -
			// disable
			// repeated
			// executions
			// before
			// first
			// ends
			)) {
				if (!bSkipPriorityCheck) { // remember scene priority that will
					// be executed
					lInfo.logln("Storing scene priority[" + action_id + "]:" + scene_priority);
					storeSubParameter('upnp', 'activeScenePriority', scene_priority);
					Property.store();
				}

				lInfo.logln("getInfo(" + raisedEvent.source.zoneID + "," + action_id + "," + nGroupID + ")");
				var arrayExecPlayers = getInfo(raisedEvent.source.zoneID, action_id, nGroupID);
				if (arrayExecPlayers.length > 0) {
					for ( var i = 0; i < arrayExecPlayers.length; i++) {
						var action_info = arrayExecPlayers[i];

						lInfo.logln("startPlay " + action_info.device + "*" + action_info.ip + "*" + action_info.port + "*" + action_info.playlist + "*" + action_info.id);

						var nAdditionalParam = 0;
						var sAction = "";
						if (action_id < 1000) {
							if (action_info.playlist.toUpperCase() == "STOP" || action_id == 999) {
								sAction = UPNP_PAUSE;
								nAdditionalParam = 1;
								//if (action_info.useDefLoudness) // if "Set default loudness" check, set def volume after stop
								//	nAdditionalParam = action_info.nDefLoudness;
							} else if (action_info.playlist.toUpperCase() == "MUTE") {
								sAction = UPNP_MUTE;
								nAdditionalParam = 1;
							} else if (action_info.playlist.toUpperCase() == "UNMUTE") {
								sAction = UPNP_MUTE;
								nAdditionalParam = 0;
							} else if ((action_info.playlist.split(' ').length == 2) && (action_info.playlist.split(' ')[0].toUpperCase() == "VOLUME")) {
								sAction = UPNP_SET_VOLUME;
								nAdditionalParam = parseInt(action_info.playlist.split(' ')[1],10);
							} else if (action_info.playlist.toUpperCase() == "TOGGLE PAUSE") {
								sAction = UPNP_TOGGLE_PAUSE;
								// playsong
							} else if (action_info.playlist.toUpperCase() == "PAUSE") {
								sAction = UPNP_PAUSE;
								nAdditionalParam = 1; // remember current
								// playsong
							} else if (action_info.playlist.toUpperCase() == "UNPAUSE") {
								sAction = UPNP_UNPAUSE;
							} else if (action_info.playlist != "") {
								if (action_id == -1) // doorbell
								{
									sAction = UPNP_LOAD_CONTENT_AND_RESUME;
									nAdditionalParam = action_info.nDoorbellPlayTime;
								} else {
									sAction = UPNP_LOAD_CONTENT_AND_PLAY;
									if (action_info.bResumeAfterAlarms && action_id >= -6 && action_id <= -3) {
										nAdditionalParam = 1; // remember
										// current
										// playsong
									}
								}
							}
						} else
							switch (action_id) {
							case 1111:
								if (nGroupID == 4) // only on audio group
									sAction = UPNP_DEC_VOLUME;
								break;

							case 1112:
								if (nGroupID == 4) // only on audio group
									sAction = UPNP_INC_VOLUME;
								break;

							case 1113:
								sAction = UPNP_STOP;
								nAdditionalParam = -1;
								if (action_info.useDefLoudness) // if "Set default loudness" check, set def volume after stop
									nAdditionalParam = action_info.nDefLoudness;
								break;
							}

						if (sAction != "") {
							lInfo.logln("Call executeUpnpCmd: " + sAction);
							executeUpnpCmd(sAction, action_info.device // device type
							, action_info.ip, action_info.port, nAdditionalParam // Additional value optional
							, action_info.playlist, action_info.id // player id
							);
						} else
							lInfo.logln("Invalid call action: " + action_info.playlist);
					}
				}
			} else {
				if (!bSkipPriorityCheck) {
					lInfo.logln("Current executed scene has to low priority[" + scene_priority + "] to override still active scene[" + nStoredActivePriority + "]");
				}
			}

		}
	}
}

else if (raisedEvent.name === 'undoScene') {
	lInfo.logln("undoScene event name: ", raisedEvent.name);
	if (raisedEvent.source.isDevice) {
		lInfo.logln("undoScene parameter device dSID: ", raisedEvent.source.dsid);
	} else {
		lInfo.logln("undoScene  parameter groupID: ", raisedEvent.source.groupID);
	}
	lInfo.logln("undoScene  parameter zoneID:  ", raisedEvent.source.zoneID);
	lInfo.logln("undoScene  parameter sceneID: ", raisedEvent.parameter.sceneID);

	var callData = convertCallSceneID(raisedEvent.parameter.sceneID);
	var action_id = callData.action_id;
	var scene_priority = callData.scene_priority;

	if (action_id != 0) {

		var nStoredActivePriority = 0;
		nStoredActivePriority = loadSubParameter('upnp', 'activeScenePriority');
		if (isNaN(nStoredActivePriority))
			nStoredActivePriority = 0;

		if (scene_priority >= nStoredActivePriority) {

			lInfo.logln("getInfo(" + raisedEvent.source.zoneID + "," + action_id + ")");

			var arrayExecPlayers = getInfo(raisedEvent.source.zoneID, action_id, 0);

			if (arrayExecPlayers.length > 0) {
				for ( var i = 0; i < arrayExecPlayers.length; i++) {
					var action_info = arrayExecPlayers[i];
					var sAction = "";
					if (action_info.bResumeAfterAlarms) {
						switch (action_id) {
						case -3:
						case -4:
						case -5:
						case -6:
							sAction = UPNP_RESUME_ALARM;
							break;
						}

						sPlay = Property.getProperty("/scripts/upnp-controller/activity/" + action_info.id + "/lastAlarmTrack");
						if (sPlay != "") {
							if (sAction != "") {
								lInfo.logln("Call executeUpnpCmd: " + sAction + " / play: " + sPlay + " playerID:" + action_info.id);
								executeUpnpCmd(sAction, action_info.device // device
								// type
								, action_info.ip, action_info.port, nAdditionalParam // Additional
																						// value
								// optional
								, sPlay, action_info.id // player id
								);
							} else
								lInfo.logln("Invalid call action");
						} else
							lInfo.logln("No music to resume from undoScene");
					}
				}
			}

			// reseting scene priority
			lInfo.logln("reseting scene priority on undoScene!");
			storeSubParameter('upnp', 'activeScenePriority', 0);
			Property.store();
		}
	}
}
